﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RefactorPracticeCons.SwitchRefactor
{
    public abstract class Employee_Sub
    {
        private const int ENGINEER = 1;
        private const int SALESMAN = 2;
        private const int MANAGER = 3;

        public static Employee_Sub Create(int type)
        {
            Employee_Sub employee = null;

            switch (type)
            {
                case ENGINEER:
                    employee = new Engineer_Sub();
                    break;
                case SALESMAN:
                    employee = new Salesman_Sub();
                    break;
                case MANAGER:
                    employee = new Manager_Sub();
                    break;
            }

            return employee;
        }

        public abstract decimal getEmployeeSalary();
    }
}
