﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RefactorPracticeCons.SwitchRefactor;

namespace RefactorPracticeCons
{
    class Program
    {
        static void Main(string[] args)
        {
            // original way for getting employee's salary
            var employee = new Employee_Ori(2);
            Console.WriteLine("Salesman(type 2)'s salary is {0}.", employee.getEmployeeSalary());

            // subclass way replaces switch case way
            var emp = Employee_Sub.Create(1);
            Console.WriteLine("Engineer(type 1)'s salary is {0}.", emp.getEmployeeSalary());

            // state way replaces switch case way
            var empl = new Employee_State(3);
            Console.WriteLine("Manager(type 3)'s salary is {0}.", empl.getEmployeeSalary());

            Console.ReadLine();
        }
    }
}
