﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RefactorPracticeCons.SwitchRefactor
{
public class Employee_Ori
{
    private int _type;

    private const int ENGINEER = 1;
    private const int SALESMAN = 2;
    private const int MANAGER = 3;

    private decimal _baseSalary = 10000;
    private decimal _royalty = 100;
    private decimal _bonus = 400;

    public Employee_Ori(int type)
    {
        this._type = type;
    }

    public decimal getEmployeeSalary()
    {
        var monthlySalary = 0m;

        switch (this._type)
        { 
            case ENGINEER:
                monthlySalary = _baseSalary;
                break;
            case SALESMAN:
                monthlySalary = _baseSalary + _royalty;
                break;
            case MANAGER:
                monthlySalary = _baseSalary + _bonus;
                break;
        }

        return monthlySalary;
    }
}
}
